Description

Yesterday I saw some old C4 code.  In it the author had a call of the form ScalarProduct(M[I],L) where M is a matrix and L a list. 

Presumably it worked in C4; but it does not in C5 because ScalarProduct expects two lists.

An easy workaround is to write ScalarProduct(GetRow(M,I),L); not as compact or elegant as the C4 version, but its meaning is clear. 

I believe the function GetRow actually copies the entries, so there is a little wasted effort...

Should we extend ScalarProduct to accept MATRIXROW?

Related issues:

Related to CoCoA-5 - Support #1031: ScalarProduct: exact defn and manual page New 17 Mar 2017

Related to CoCoA-5 - Feature #1296: Matrixrow-functions In Progress 16 Jun 2019

History

#1 - 21 Mar 2014 10:31 - John Abbott

I'm rather undecided about this.

I suppose KISS would say not to widen the arg types accepted by ScalarProduct, at least no until we observe that it is a frequent paradigm.

One "irritating" aspect is that the obvious C5 implementation would probably work with MATRIXROW args.  Actually, the only obstacle to it working is

that len throws when given a MATRIXROW.

Opinions?

#2 - 21 Mar 2014 10:39 - Anna Maria Bigatti

- Target version set to CoCoA-5.1.0 Easter14

I like defining (mathematically) matrix multiplication by scalar products, so I'm in favour of adding it.

GetRow would makes copies, so can get quite costly in a loop.

I don't think it is trivial to implement, probably "not hard".

#3 - 09 Apr 2014 14:55 - John Abbott

- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.1.1 Seoul14

#4 - 22 Jul 2014 09:32 - Anna Maria Bigatti

- Target version changed from CoCoA-5.1.1 Seoul14 to CoCoA-5.?.?

I think it is possible, but tedious work.  Is it worth the effort?
#5 - 17 Mar 2017 11:01 - John Abbott

- Related to Support #1031: ScalarProduct: exact defn and manual page added

#6 - 18 Jun 2019 15:17 - Anna Maria Bigatti

- Related to Feature #1296: Matrixrow-functions added

#7 - 18 Jun 2019 15:22 - Anna Maria Bigatti

Anna Maria Bigatti wrote:

I like defining (mathematically) matrix multiplication by scalar products, so I'm in favour of adding it.

GetRow would makes copies, so can get quite costly in a loop.

I don't think it is trivial to implement, probably "not hard".

 

I changed my mind: MATRIXROW is a very dodgy type.
